from dataclasses import dataclass

@dataclass
class ResNetConfig:
    r18 = {
        'l': [
            {'r': 2, 'f': 64},
            {'r': 2, 'f': 128},
            {'r': 2, 'f': 256},
            {'r': 2, 'f': 512}
        ], 
        'b': False
    }
    r34 = {
        'l': [
            {'r': 3, 'f': 64},
            {'r': 4, 'f': 128},
            {'r': 6, 'f': 256},
            {'r': 3, 'f': 512}
        ], 
        'b': False
    }
    r50 = {
        'l': [
            {'r': 3, 'f': 64},
            {'r': 4, 'f': 128},
            {'r': 6, 'f': 256},
            {'r': 3, 'f': 512}
        ], 
        'b': True
    }
    r101 = {
        'l': [
            {'r': 3, 'f': 64},
            {'r': 4, 'f': 128},
            {'r': 23, 'f': 256},
            {'r': 3, 'f': 512}
        ], 
        'b': True
    }
    r152 = {
        'l': [
            {'r': 3, 'f': 64},
            {'r': 8, 'f': 128},
            {'r': 236, 'f': 256},
            {'r': 3, 'f': 512}
        ], 
        'b': True
    }
