from dataclasses import dataclass

@dataclass
class VGGConfig:
    vgg11 = {
        'd': 0.5, 
        'bn': False, 
        'l': [
            {'r': 1, 'f': 64},
            {'r': 1, 'f': 128},
            {'r': 2, 'f': 256},
            {'r': 2, 'f': 512},
            {'r': 2, 'f': 512}
        ]   
    }        
    vgg13 = {
        'd': 0.5, 
        'bn': False, 
        'l': [
            {'r': 2, 'f': 64},
            {'r': 2, 'f': 128},
            {'r': 2, 'f': 256},
            {'r': 2, 'f': 512},
            {'r': 2, 'f': 512},
        ]
    }
    vgg16 = {
        'd': 0.5, 
        'bn': False, 
        'l': [
            {'r': 2, 'f': 64},
            {'r': 2, 'f': 128},
            {'r': 3, 'f': 256},
            {'r': 3, 'f': 512},
            {'r': 3, 'f': 512},
        ]
    }
    vgg19 = {
        'd': 0.5, 
        'bn': False, 
        'l': [
            {'r': 2, 'f': 64},
            {'r': 2, 'f': 128},
            {'r': 4, 'f': 256},
            {'r': 4, 'f': 512},
            {'r': 4, 'f': 512},
        ]
    }